/* create a table where the primary key name is not
   specified, and the database will assign it */

Create TABLE TABLE_A
( COLUMN_A smallint PRIMARY KEY)
go

/* Now create a primary key specifying the name */
Create TABLE TABLE_B
( COLUMN_B smallint CONSTRAINT PK_COLUMN_B PRIMARY KEY)
go

/* Now create a foreign key referencing TABLE_A */
Create TABLE TABLE_C
( COLUMN_C smallint FOREIGN KEY (COLUMN_C) REFERENCES TABLE_A(COLUMN_A))
go

/* Now Create a multi-column primary key */
Create TABLE TABLE_D
( COLUMN_D1 smallint CONSTRAINT PK_D_COLUMNS PRIMARY KEY 
(COLUMN_D1, COLUMN_D2), COLUMN_D2 smallint)

go

/* now create a foreign key referencing the multi-column
   primary key */
Create TABLE TABLE_E
( COLUMN_E1 smallint FOREIGN KEY (COLUMN_E1, COLUMN_E2)
                  REFERENCES TABLE_D( COLUMN_D1, COLUMN_D2),
  COLUMN_E2 smallint)
go
