IF object_id('Maintain_Employees') IS NOT NULL
   DROP PROCEDURE Maintain_Employees
GO

CREATE PROCEDURE Maintain_Employees
AS
/*  ,      */
DECLARE  @dtPubDate   DATETIME,
         @nEmplCount  SMALLINT,
         @nEmplID     EMPID,
         @nFirstHalf  SMALLINT,
         @nRowCount   INTEGER,
         @nSecondHalf INTEGER,
         @nSQLError   INTEGER,
         @nYtdSales   INTEGER,
         @sLName      VARCHAR(30),
         @sPubID      CHAR(4),
         @sLastType   CHAR(12),
         @sType       CHAR(12)

/*   .
 , ,    WHERE 
  ,   
      .
  ,  
    -  
  . */
DECLARE Cur_Empl CURSOR
FOR SELECT emp_id, lname, pub_id
 FROM Employee
 ORDER BY emp_id

Declare Cur_Titles Cursor
FOR SELECT type, pubdate, ytd_sales
 FROM Titles
 WHERE pub_id = @sPubID
 ORDER BY type

/*         */
OPEN Cur_Empl
FETCH Cur_Empl
INTO @nEmplID, @sLName, @sPubID

/*   */
SELECT @nEmplCount = 0

/*          */
WHILE @@Fetch_Status = 0
BEGIN

    /*   */
    SELECT @nEmplCount = @nEmplCount + 1

    /*        */
    Select @nEmplID, @sLName

    /*   ,   A-C    GOTO */
    If @sLName < 'D'
        GOTO Fetch_Next_Empl

    /*        
       */
    OPEN Cur_Titles
    FETCH Cur_Titles
    INTO @sType, @dtPubDate, @nYtdSales

    /*   */
    SELECT @nFirstHalf   = 0,
           @nSecondHalf  = 0,
           @sLastType    = NULL

    WHILE @@Fetch_Status = 0
    BEGIN
        If @sType != @sLastType AND @sLastType != NULL
        BEGIN

            /*     */
            Select @sLastType, @nFirstHalf, @nSecondHalf

            /*    */
            SELECT  @nFirstHalf  = 0,
                    @nSecondHalf = 0
        END

        If @dtPubDate <= '30/6/95'
            SELECT @nFirstHalf = @nFirstHalf + @nYtdSales,
                @sLastType = @sType
        ELSE
            SELECT @nSecondHalf = @nSecondHalf + @nYtdSales,
                @sLastType = @sType

        FETCH Cur_Titles
        INTO  @sType, @dtPubDate, @nYtdSales
    END
    /* ,      */
    Fetch_Next_Empl:
    FETCH Cur_Empl
    INTO @nEmplID,  @sLName, @sPubID
END
/*    .  ,  
     , 
       
.     
    . */
CLOSE Cur_Empl
CLOSE Cur_Titles
DEALLOCATE Cur_Empl
DEALLOCATE Cur_Titles

/*     */
SELECT @nEmplCount

/*    */
RETURN 0
GO